libstdc++: std::insert_iterator< _Container > Class Template Reference

libstdc++

std::insert_iterator< _Container > Class Template Reference
Iterators

`#include <stl_iterator.h>`

Inheritance diagram for std::insert_iterator< _Container >:
[legend]

## Public Types
typedef _Container | container_type
using | difference_type
typedef output_iterator_tag | iterator_category
typedef void | pointer
typedef void | reference
typedef void | value_type

## Public Member Functions
constexpr | insert_iterator (_Container &__x, _Iter __i)
constexpr insert_iterator & | operator* ()
constexpr insert_iterator & | operator++ ()
constexpr insert_iterator & | operator++ (int)
constexpr insert_iterator & | operator= (const typename _Container::value_type &__value)
constexpr insert_iterator & | operator= (typename _Container::value_type &&__value)

## Protected Attributes
_Container * | container
_Iter | iter

## Detailed Description

template<typename _Container>
class std::insert_iterator< _Container >

Turns assignment into insertion.

These are output iterators, constructed from a container-of-T. Assigning a T to the iterator inserts it in the container at the iterator's position, rather than overwriting the value at that position.

(Sequences will actually insert a copy of the value before the iterator's position.)

Tip: Using the inserter function to create these iterators can save typing.

Definition at line 883 of file bits/stl_iterator.h.

## Member Typedef Documentation

## ◆ container_type

template<typename _Container>

typedef _Container std::insert_iterator< _Container >::container_type

A nested typedef for the type of whatever container you used.

Definition at line 897 of file bits/stl_iterator.h.

## ◆ difference_type

template<typename _Container>

using std::insert_iterator< _Container >::difference_type

Definition at line 900 of file bits/stl_iterator.h.

## ◆ iterator_category

typedef output_iterator_tag std::iterator< output_iterator_tag, void, void, void, void >::iterator_category
| inherited

One of the tag types.

Definition at line 137 of file stl_iterator_base_types.h.

## ◆ pointer

typedef void std::iterator< output_iterator_tag, void, void, void, void >::pointer
| inherited

This type represents a pointer-to-value_type.

Definition at line 143 of file stl_iterator_base_types.h.

## ◆ reference

typedef void std::iterator< output_iterator_tag, void, void, void, void >::reference
| inherited

This type represents a reference-to-value_type.

Definition at line 145 of file stl_iterator_base_types.h.

## ◆ value_type

typedef void std::iterator< output_iterator_tag, void, void, void, void >::value_type
| inherited

The type "pointed to" by the iterator.

Definition at line 139 of file stl_iterator_base_types.h.

## Constructor & Destructor Documentation

## ◆ insert_iterator()

template<typename _Container>

std::insert_iterator< _Container >::insert_iterator | ( | _Container & | __x,
|  | _Iter | __i )
| inlineconstexpr

The only way to create this iterator is with a container and an initial position (a normal iterator into the container).

Definition at line 908 of file bits/stl_iterator.h.

References std::__addressof().

## Member Function Documentation

## ◆ operator*()

template<typename _Container>

insert_iterator & std::insert_iterator< _Container >::operator* | ( |  | ) |
| inlinenodiscardconstexpr

Simply returns *this.

Definition at line 965 of file bits/stl_iterator.h.

## ◆ operator++() [1/2]

template<typename _Container>

insert_iterator & std::insert_iterator< _Container >::operator++ | ( |  | ) |
| inlineconstexpr

Simply returns *this. (This iterator does not move.).

Definition at line 971 of file bits/stl_iterator.h.

## ◆ operator++() [2/2]

template<typename _Container>

insert_iterator & std::insert_iterator< _Container >::operator++ | ( | int |  | ) |
| inlineconstexpr

Simply returns *this. (This iterator does not move.).

Definition at line 977 of file bits/stl_iterator.h.

## ◆ operator=() [1/2]

template<typename _Container>

insert_iterator & std::insert_iterator< _Container >::operator= | ( | const typename _Container::value_type & | __value | ) |
| inlineconstexpr

Parameters

  __value | An instance of whatever type container_type::const_reference is; presumably a reference-to-const T for container<T>.

Returns
  This iterator, for chained operations.

This kind of iterator maintains its own position in the container. Assigning a value to the iterator will insert the value into the container at the place before the iterator.

The position is maintained such that subsequent assignments will insert values immediately after one another. For example,

// vector v contains A and Z
insert_iterator i (v, ++v.begin());
i = 1;
i = 2;
i = 3;
// vector v contains A, 1, 2, 3, and Z
std::insert_iterator::insert_iterator
constexpr insert_iterator(_Container &__x, _Iter __i)
Definition bits/stl_iterator.h:908

Definition at line 945 of file bits/stl_iterator.h.

## ◆ operator=() [2/2]

template<typename _Container>

insert_iterator & std::insert_iterator< _Container >::operator= | ( | typename _Container::value_type && | __value | ) |
| inlineconstexpr

Definition at line 954 of file bits/stl_iterator.h.

## Member Data Documentation

## ◆ container

template<typename _Container>

_Container* std::insert_iterator< _Container >::container
| protected

Definition at line 892 of file bits/stl_iterator.h.

## ◆ iter

template<typename _Container>

_Iter std::insert_iterator< _Container >::iter
| protected

Definition at line 893 of file bits/stl_iterator.h.

The documentation for this class was generated from the following file:

- bits/stl_iterator.h